## openms 2.4.0-real

=== debian/changelog ===
openms (2.4.0-real-1ubuntu4) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Mar 2020 08:54:51 +0100

openms (2.4.0-real-1ubuntu3) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:22:09 +0100

openms (2.4.0-real-1ubuntu2) focal; urgency=medium

  * Cherrypick upstream patches to fix latex documentation.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 20 Feb 2020 11:50:12 +0000

openms (2.4.0-real-1ubuntu1) focal; urgency=medium

  * Export HOME for cmake.
  * Try to unbreak cmake/boost detection issues.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 19 Feb 2020 12:30:30 +0000

openms (2.4.0-real-1build2) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 21:12:53 +0000

openms (2.4.0-real-1build1) eoan; urgency=medium

  * No change rebuild against new boost regex icu encoded abi ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 08 May 2019 18:07:35 +0100

openms (2.4.0-real-1) unstable; urgency=low

  * Really released 2.4.0 version with Qt5 port merged;

  * d/control: update website url to http://www.openms.de (thanks to Adrian Bunk
    <bunk@debian.org>; Closes: #906561);

  * d/copyright: update website url and copyright years.
    add Design Science License (Thanks to Dmitry Smirnov
    <onlyjob@debian.org>, Closes: #822412);

  * d/control: fix libqt5opengl5-dev (>= 5.7.0) to libqt5opengl5-desktop-dev
    (>= 5.7.0) because upstream won't support OpenGL ES anytime soon (thanks
    to Adrian Bunk <bunk@debian.org>, Closes: #906666);

  * Use secure copyright file specification URI.
  * Trim trailing whitespace.
    Jelmer Vernooĳ <jelmer@debian.org>  Mon, 15 Oct 2018 06:59:37 +0000

  * debian/control: Change "Conflicts:" to "Breaks:" (Closes:
    #816562);

 -- Filippo Rusconi <lopippo@debian.org>  Sat, 17 Nov 2018 17:24:48 +0100
