=== debian/watch ===
version=3

#http://sf.net/open-ms/OpenMS-([\d\.]+)\.tar\..*
#http://sourceforge.net/projects/open-ms/files/OpenMS/OpenMS-2.0/OpenMS-([\d\.]+)_src\.tar\.gz.*

http://sf.net/open-ms/OpenMS-(.+)\.tar\.gz
